---
- name: Set default facts for K8S
  ansible.builtin.set_fact:
    k8s_config: "{{ K8S_KUBECONFIG_PATH }}/{{ inv_am.apim.ns_kubeconfig }}"
    k8s_context: "{{ inv_k8s.config.context }}"
    k8s_namespace: "{{ inv_am.apim.ns_name | lower }}"

# 1. Create namespace for APIM stack
- name: "Create namespace {{ k8s_namespace }}"
  kubernetes.core.k8s:
    state: present
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    definition:
      api_version: v1
      kind: Namespace
      metadata:
        name: "{{ k8s_namespace }}"
        labels:
          name: "{{ k8s_namespace }}"
  when: inv_am.apim.ns_create == "true"

# 2. Setup Gravitee with all required resources
- name: Setup Gravitee with all required resources
  import_tasks: tasks/10_apim_stack/setup_gravitee.yml

# 3. Setup velero backup
- name: "Create velrero Backup schedule naemspace {{ k8s_namespace }}"
  kubernetes.core.k8s:
    state: present
    kubeconfig: "{{ k8s_config }}"
    context: "{{ k8s_context }}"
    namespace: "{{ inv_op_stack.velero.ns_name }}"
    definition:
      apiVersion: velero.io/v1
      kind: Schedule
      metadata:
        name: "{{ k8s_namespace }}-backup"
      spec:
        schedule: 0 2 * * *
        template:
          defaultVolumesToRestic: true
          hooks: {}
          includedNamespaces:
            - '{{ k8s_namespace }}'
          metadata: {}
          snapshotVolumes: true
          storageLocation: "{{ inv_op_stack.velero.backup.location_name }}-backup"
          ttl: 720h0m0s
  when: inv_op_stack.velero.enable == "true"
